diff --git a/test/functional/lookup_keys_controller_test.rb b/test/functional/lookup_keys_controller_test.rb
index 7dc467c..a9cd045 100644
--- a/test/functional/lookup_keys_controller_test.rb
+++ b/test/functional/lookup_keys_controller_test.rb
@@ -38,4 +38,21 @@ class LookupKeysControllerTest < ActionController::TestCase
 
     assert_redirected_to lookup_keys_path
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit an external variable' do
+    setup_user
+    get :edit, {:id => LookupKey.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing external variables' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/medias_controller_test.rb b/test/functional/medias_controller_test.rb
index 04ff7ae..bfaa743 100644
--- a/test/functional/medias_controller_test.rb
+++ b/test/functional/medias_controller_test.rb
@@ -46,4 +46,21 @@ class MediasControllerTest < ActionController::TestCase
     assert_redirected_to medias_url
     assert !Media.exists?(media.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a media' do
+    setup_user
+    get :edit, {:id => Media.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing medias' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/models_controller_test.rb b/test/functional/models_controller_test.rb
index e15effd..c8bc1db 100644
--- a/test/functional/models_controller_test.rb
+++ b/test/functional/models_controller_test.rb
@@ -46,4 +46,21 @@ class ModelsControllerTest < ActionController::TestCase
     assert_redirected_to models_url
     assert !Model.exists?(model.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a model' do
+    setup_user
+    get :edit, {:id => Model.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing models' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/operatingsystems_controller_test.rb b/test/functional/operatingsystems_controller_test.rb
index 3b16ab5..02bad4b 100644
--- a/test/functional/operatingsystems_controller_test.rb
+++ b/test/functional/operatingsystems_controller_test.rb
@@ -49,4 +49,21 @@ class OperatingsystemsControllerTest < ActionController::TestCase
     assert_redirected_to operatingsystems_url
     assert !Operatingsystem.exists?(operatingsystem.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit an operating system' do
+    setup_user
+    get :edit, {:id => Operatingsystem.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing operatingsystems' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/ptables_controller_test.rb b/test/functional/ptables_controller_test.rb
index 62cdccd..1fb0423 100644
--- a/test/functional/ptables_controller_test.rb
+++ b/test/functional/ptables_controller_test.rb
@@ -48,8 +48,63 @@ class PtablesControllerTest < ActionController::TestCase
 
   def test_destroy
     ptable = Ptable.first
-    delete :destroy, {:id => ptable.id}, set_session_user
+    ptable.hosts = []
+    delete :destroy, {:id => ptable}, set_session_user
     assert_redirected_to ptables_url
     assert !Ptable.exists?(ptable.id)
   end
+
+  def setup_view_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a partition table' do
+    setup_view_user
+    get :edit, {:id => Ptable.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should fail to delete a partition table' do
+    setup_view_user
+    delete :destroy, {:id => Ptable.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should fail to create a partition table' do
+    setup_view_user
+    post :create, {:ptable => {:name => "dummy", :layout => "dummy"}}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing partition tables' do
+    setup_view_user
+    get :index
+    assert_response :success
+  end
+
+  def setup_edit_user
+    @user = User.find_by_login("one")
+    @user.roles = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer'), Role.find_by_name('Edit partition tables')]
+    @request.session[:user] = @user.id
+  end
+
+
+  test 'user with editing rights should succeed in editing a partition table' do
+    setup_edit_user
+    get :edit, {:id => Ptable.first.id}
+    assert_response :success
+  end
+
+  test 'user with editing rights should succeed in deleting a partition table' do
+    setup_edit_user
+    delete :destroy, {:id => Ptable.first.id}
+    assert flash[:foreman_notice] = "Successfully destroyed partition table."
+  end
+
+  test 'user with editing rights should succeed in creating a partition table' do
+    setup_edit_user
+    post :create, {:ptable => {:name => "dummy", :layout => "dummy"}}
+    assert flash[:foreman_notice] = "Successfully created partition table."
+  end
 end
diff --git a/test/functional/puppetclasses_controller_test.rb b/test/functional/puppetclasses_controller_test.rb
index affa372..0b059ca 100644
--- a/test/functional/puppetclasses_controller_test.rb
+++ b/test/functional/puppetclasses_controller_test.rb
@@ -46,4 +46,21 @@ class PuppetclassesControllerTest < ActionController::TestCase
     assert_redirected_to puppetclasses_url
     assert !Puppetclass.exists?(puppetclass.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a puppetclass' do
+    setup_user
+    get :edit, {:id => Puppetclass.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing puppetclasses' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/reports_controller_test.rb b/test/functional/reports_controller_test.rb
index b5da489..e50c6ad 100644
--- a/test/functional/reports_controller_test.rb
+++ b/test/functional/reports_controller_test.rb
@@ -1,6 +1,9 @@
 require 'test_helper'
 
 class ReportsControllerTest < ActionController::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   def test_index
     get :index, {}, set_session_user
     assert_response :success
@@ -62,4 +65,21 @@ class ReportsControllerTest < ActionController::TestCase
   def create_a_puppet_transaction_report
     @log = File.read(File.expand_path(File.dirname(__FILE__) + "/../fixtures/report-skipped.yaml"))
   end
+
+  def user_setup
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a report' do
+    user_setup
+    get :edit, {:id => Report.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing reports' do
+    user_setup
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/roles_controller_test.rb b/test/functional/roles_controller_test.rb
new file mode 100644
index 0000000..205b033
--- /dev/null
+++ b/test/functional/roles_controller_test.rb
@@ -0,0 +1,125 @@
+# redMine - project management software
+# Copyright (C) 2006-2007  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+require File.dirname(__FILE__) + '/../test_helper'
+require 'roles_controller'
+
+# Re-raise errors caught by the controller.
+class RolesController; def rescue_action(e) raise e end; end
+
+class RolesControllerTest < ActionController::TestCase
+  fixtures :roles, :users
+
+  def setup
+    @controller = RolesController.new
+    @request    = ActionController::TestRequest.new
+    @response   = ActionController::TestResponse.new
+    User.current = nil
+    @request.session[:user] = users(:admin).id # admin
+  end
+
+  def test_get_index
+    get :index
+    assert_response :success
+    assert_template 'index'
+
+    assert_not_nil assigns(:roles)
+    assert_equal Role.find(:all).sort, [assigns(:roles)].flatten.sort
+
+    assert_tag :tag => 'a', :attributes => { :href => '/roles/1/edit' },
+      :content => 'Manager'
+  end
+
+  def test_get_new
+    get :new
+    assert_response :success
+    assert_template 'new'
+  end
+
+  def test_post_new_with_validaton_failure
+    post :create, :role => {:name => '',
+      :permissions => ['add_hosts', 'edit_hosts', 'edit_ptables', '']
+    }
+
+    assert_response :success
+    assert_template 'new'
+    assert_tag :tag => 'div', :attributes => { :id => 'errorExplanation' }
+  end
+
+  def test_get_edit
+    get :edit, :id => 1
+    assert_response :success
+    assert_template 'edit'
+    assert_equal Role.find(1), assigns(:role)
+  end
+
+  def test_post_edit
+    put :update, :id => 1,
+      :role => {:name => 'Manager',
+        :permissions => ['edit_hosts']
+    }
+
+    assert_redirected_to 'roles'
+    role = Role.find(1)
+    assert_equal [:edit_hosts], role.permissions
+  end
+
+  def test_destroy
+    r = Role.new(:name => 'ToBeDestroyed', :permissions => [:view_ptables])
+    assert r.save
+
+    delete :destroy, :id => r
+    assert_redirected_to 'roles'
+    assert_nil Role.find_by_id(r.id)
+  end
+
+  def test_destroy_role_in_use
+    users(:one).roles = [roles(:manager)] # make user one a manager
+    delete :destroy, {:id => roles(:manager)}
+    assert_redirected_to roles_path
+    assert_equal 'Role is in use', flash[:foreman_error]
+    assert_not_nil Role.find_by_id(roles(:manager).id)
+  end
+
+  def test_get_report
+    get :report
+    assert_response :success
+    assert_template 'report'
+
+    assert_not_nil assigns(:roles)
+    assert_equal Role.find(:all).sort, assigns(:roles).sort
+
+  end
+
+  def test_post_report
+    post :report, :permissions => { '0' => '', '1' => ['edit_issues'], '3' => ['add_issues', 'delete_issues']}
+    assert_redirected_to 'roles'
+
+    assert_equal [:edit_issues], Role.find(1).permissions
+    assert_equal [:add_issues, :delete_issues], Role.find(3).permissions
+    assert Role.find(2).permissions.empty?
+  end
+
+  def test_clear_all_permissions
+    post :report, :permissions => { '0' => '' }
+    assert_redirected_to 'roles'
+    assert Role.find(1).permissions.empty?
+  end
+
+  viewable = %w{Architecture Audit AuthSourceLdap Dashboard Domain Environment LookupKey FactValue CommonParameter Hostgroup Host Media Model Operatingsystem Ptable Puppetclass Report Setting Statistic Usergroup User}
+  editable = %w{Architecture Audit AuthSourceLdap           Domain Environment LookupKey           CommonParameter Hostgroup Host Media Model Operatingsystem Ptable Puppetclass Report                   Usergroup User}
+end
diff --git a/test/functional/statistics_controller_test.rb b/test/functional/statistics_controller_test.rb
index a2838cc..b86df1e 100644
--- a/test/functional/statistics_controller_test.rb
+++ b/test/functional/statistics_controller_test.rb
@@ -5,4 +5,11 @@ class StatisticsControllerTest < ActionController::TestCase
   test "the truth" do
     assert true
   end
+
+  test 'user with viewer rights should succeed in viewing statistics' do
+    @request.session[:user] = users(:one).id
+    users(:one).roles = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/usergroups_controller_test.rb b/test/functional/usergroups_controller_test.rb
index b89f172..53311c2 100644
--- a/test/functional/usergroups_controller_test.rb
+++ b/test/functional/usergroups_controller_test.rb
@@ -46,4 +46,21 @@ class UsergroupsControllerTest < ActionController::TestCase
     assert_redirected_to usergroups_url
     assert !Usergroup.exists?(usergroup.id)
   end
+
+  def setup_user
+    @request.session[:user] = users(:one).id
+    users(:one).roles       = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+  end
+
+  test 'user with viewer rights should fail to edit a usergroup' do
+    setup_user
+    get :edit, {:id => Usergroup.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing usergroups' do
+    setup_user
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/functional/users_controller_test.rb b/test/functional/users_controller_test.rb
index b47f050..abd3df4 100644
--- a/test/functional/users_controller_test.rb
+++ b/test/functional/users_controller_test.rb
@@ -70,7 +70,7 @@ class UsersControllerTest < ActionController::TestCase
 
   test "should delete different user" do
     user = users(:one)
-    delete :destroy, {:id => user}, {:user => users(:two)}
+    delete :destroy, {:id => user}, {:user => users(:admin)}
     assert_redirected_to users_url
     assert !User.exists?(user.id)
   end
@@ -79,6 +79,7 @@ class UsersControllerTest < ActionController::TestCase
     return unless SETTINGS[:login]
     @request.env['HTTP_REFERER'] = users_path
     user = users(:one)
+    user.update_attribute :admin, true
     delete :destroy, {:id => user.id}, {:user => user.id}
     assert_redirected_to users_url
     assert User.exists?(user)
@@ -94,4 +95,23 @@ class UsersControllerTest < ActionController::TestCase
     assert !User.find_by_login("admin").nil?
   end
 
+  def setup_users
+    User.current = users :admin
+    user = User.find_by_login("one")
+    @request.session[:user] = user.id
+    user.roles = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
+    user.save!
+  end
+
+  test 'user with viewer rights should fail to edit a user' do
+    setup_users
+    get :edit, {:id => User.first.id}
+    assert @response.status == '403 Forbidden'
+  end
+
+  test 'user with viewer rights should succeed in viewing users' do
+    setup_users
+    get :index
+    assert_response :success
+  end
 end
diff --git a/test/test_helper.rb b/test/test_helper.rb
index ccb3e86..4cb031d 100644
--- a/test/test_helper.rb
+++ b/test/test_helper.rb
@@ -46,9 +46,17 @@ class ActiveSupport::TestCase
 
   def set_session_user
     if SETTINGS[:login]
-      {:user => User.first.id}
+      {:user => User.find_by_login("admin")}
     else
       {}
     end
   end
+  
+  def as_admin
+    saved_user   = User.current
+    User.current = users(:admin)
+    result = yield
+    User.current = saved_user
+    result
+  end
 end
diff --git a/test/unit/architecture_test.rb b/test/unit/architecture_test.rb
index b0ddc3d..9dfb53e 100644
--- a/test/unit/architecture_test.rb
+++ b/test/unit/architecture_test.rb
@@ -1,6 +1,9 @@
 require 'test_helper'
 
 class ArchitectureTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login("admin")
+  end
   test "should not save without a name" do
     architecture = Architecture.new
     assert !architecture.save
@@ -48,4 +51,60 @@ class ArchitectureTest < ActiveSupport::TestCase
 
     assert !architecture.destroy
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_architectures"
+      role.permissions = ["#{operation}_architectures".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Architecture.create :name => "dummy"
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Architecture.create :name => "dummy"
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Architecture.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Architecture.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Architecture.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Architecture.first
+    record.name = "renamed"
+    assert !record.save
+  end
 end
diff --git a/test/unit/auth_source_ldap_test.rb b/test/unit/auth_source_ldap_test.rb
index 8d83eab..8afd0c0 100644
--- a/test/unit/auth_source_ldap_test.rb
+++ b/test/unit/auth_source_ldap_test.rb
@@ -7,6 +7,7 @@ class AuthSourceLdapTest < ActiveSupport::TestCase
                     :host= => "value",
                     :attr_login= => "value",
                     :port= => 389  }
+    User.current = users(:admin)
   end
 
   test "should exists a name" do
@@ -148,4 +149,57 @@ class AuthSourceLdapTest < ActiveSupport::TestCase
   def assigns_a_string_of_length_greater_than(length, method)
     @auth_source_ldap.send method, "this is010this is020this is030this is040this is050this is060this is070this is080this is090this is100this is110this is120this is130this is140this is150this is160this is170this is180this is190this is200this is210this is220this is230this is240this is250 and something else"
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_authenticators"
+      role.permissions = ["#{operation}_authenticators".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  AuthSourceLdap.create :name => "dummy", :host => hosts(:one).name, :port => "1", :attr_login => "login" 
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  AuthSourceLdap.create :name => "dummy", :host => hosts(:one).name, :port => "1", :attr_login => "login"
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  AuthSourceLdap.first
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  AuthSourceLdap.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  AuthSourceLdap.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  AuthSourceLdap.first
+    record.name = "renamed"
+    assert !record.save
+  end
 end
diff --git a/test/unit/common_parameter_test.rb b/test/unit/common_parameter_test.rb
index 6e267f0..cc2367b 100644
--- a/test/unit/common_parameter_test.rb
+++ b/test/unit/common_parameter_test.rb
@@ -1,6 +1,9 @@
 require 'test_helper'
 
 class CommonParameterTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   test "name can't be blank" do
     parameter = CommonParameter.new :name => "  ", :value => "some_value"
     assert parameter.name.strip.empty?
@@ -52,4 +55,58 @@ class CommonParameterTest < ActiveSupport::TestCase
     assert !parameter2.valid?
     assert  parameter2.errors.full_messages[0] == "Name has already been taken"
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_global_variables"
+      role.permissions = ["#{operation}_global_variables".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  CommonParameter.create :name => "dummy", :value => "value"
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  CommonParameter.create :name => "dummy", :value => "value"
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  CommonParameter.first
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  CommonParameter.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  CommonParameter.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  CommonParameter.first
+    record.name = "renamed"
+    assert !record.save
+  end
+
 end
diff --git a/test/unit/domain_parameter_test.rb b/test/unit/domain_parameter_test.rb
index 57ab37f..8408cb4 100644
--- a/test/unit/domain_parameter_test.rb
+++ b/test/unit/domain_parameter_test.rb
@@ -22,5 +22,82 @@ class DomainParameterTest < ActiveSupport::TestCase
     parameter2 = DomainParameter.create :name => "some parameter", :value => "value", :reference_id => Domain.last.id
     assert parameter2.valid?
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_domains"
+      role.permissions = ["#{operation}_domains".to_sym]
+      @one.roles = [role]
+      @one.domains = []
+      @one.save!
+    end
+    User.current = @one
+  end
+
+  test "user with create permissions should be able to create when permitted" do
+    setup_user "create"
+    as_admin do
+      @one.domains = [domains(:mydomain)]
+    end
+    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:mydomain).id
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with create permissions should not be able to create when not permitted" do
+    setup_user "create"
+    as_admin do
+      @one.domains = [domains(:mydomain)]
+    end
+    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:yourdomain).id
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with create permissions should be able to create when unconstrained" do
+    setup_user "create"
+    as_admin do
+      @one.domains = []
+    end
+    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:mydomain).id
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:mydomain).id
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  DomainParameter.first
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  DomainParameter.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  DomainParameter.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  DomainParameter.first
+    record.name = "renamed"
+    assert !record.save
+  end
 end
 
diff --git a/test/unit/domain_test.rb b/test/unit/domain_test.rb
index f5e6158..05fac4f 100644
--- a/test/unit/domain_test.rb
+++ b/test/unit/domain_test.rb
@@ -2,6 +2,7 @@ require 'test_helper'
 
 class DomainTest < ActiveSupport::TestCase
   def setup
+    User.current = users(:admin)
     @new_domain = Domain.new
     @domain = Domain.new(:name => "myDomain")
     @domain.save
@@ -39,17 +40,22 @@ class DomainTest < ActiveSupport::TestCase
     assert_equal @domain.name, s
   end
 
-  test "should not destroy if have childrens" do
-    host = create_a_host
+  test "should not destroy if it contains hosts" do
+    host   = create_a_host
 
-    d = host.domain
-    assert !d.destroy
+    domain = host.domain
+    assert !domain.destroy
+    assert_match /is used by/, domain.errors.full_messages.join("\n")
+  end
 
-    subnet = Subnet.create  :number => "123.123.123.1", :mask => "321.321.321.1",
-                             :domain => @domain
+  test "should not destroy if it contains subnets" do
 
-    d = subnet.domain
-    assert !d.destroy
+    as_admin do
+      Subnet.create!  :number => "123.123.123.1", :mask => "321.321.321.1",
+                      :domain => @domain
+    end
+    assert !@domain.destroy
+    assert_match /is used by/, @domain.errors.full_messages.join("\n")
   end
 
 #I must find out how to create a fact_name inside of fact_value
@@ -60,12 +66,89 @@ class DomainTest < ActiveSupport::TestCase
 #  end
 
   def create_a_host
-    Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
-                 :domain => @domain,
-                 :operatingsystem => Operatingsystem.first,
-                 :architecture => Architecture.find_or_create_by_name("i386"),
-                 :environment => Environment.find_or_create_by_name("envy"),
-                 :disk => "empty partition"
+    as_admin do
+      Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
+                   :domain => @domain,
+                   :operatingsystem => Operatingsystem.first,
+                   :architecture => Architecture.find_or_create_by_name("i386"),
+                   :environment => Environment.find_or_create_by_name("envy"),
+                   :disk => "empty partition"
+    end
+  end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_domains"
+      role.permissions = ["#{operation}_domains".to_sym]
+      @one.roles = [role]
+      @one.domains = []
+      @one.save!
+    end
+    User.current = @one
+  end
+
+  test "user with edit permissions should be able to edit when permitted" do
+    setup_user "edit"
+    as_admin do
+      @one.domains = [domains(:mydomain)]
+    end
+    record =  Domain.find_by_name "mydomain.net"
+    assert record.update_attributes :name => "testing"
+    assert record.valid?
+  end
+
+  test "user with edit permissions should not be able to edit when not permitted" do
+    setup_user "edit"
+    as_admin do
+      @one.domains = [domains(:yourdomain)]
+    end
+    record =  Domain.find_by_name "mydomain.net"
+    assert !record.update_attributes(:name => "testing")
+    assert record.valid?
+  end
+
+  test "user with edit permissions should be able to edit when unconstrained" do
+    setup_user "edit"
+    record =  Domain.first
+    assert record.update_attributes :name => "testing"
+    assert record.valid?
+  end
+
+  test "user with view permissions should not be able to create when not permitted" do
+    setup_user "view"
+    record =  Domain.create :name => "dummy", :fullname => "dummy.com"
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Domain.first
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Domain.first
+    assert !record.destroy
+    assert !record.frozen?
   end
+
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Domain.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Domain.first
+    record.name = "renamed"
+    assert !record.save
+  end
+
 end
 
